<template>
  <v-container fluid>
    <v-row>
      <v-col
        v-for="({ actionIcon, actionText, ...attrs }, i) in stats"
        :key="i"
      >
        <material-stat-card
          v-bind="attrs"
          :is-loading="isStatsLoading"
        >
          <template #actions>
            <v-icon
              class="mr-2"
              small
              v-text="actionIcon"
            />
            <div class="text-truncate">
              {{ actionText }}
            </div>
          </template>
        </material-stat-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
  import getStats from '../stats'

  export default {
    name: 'Stats',
    data () {
      return {
        isStatsLoading: false,
        stats: getStats(key => this.$t(key)),
      }
    },
    computed: {
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
    },
    watch: {
      selectedPeriod: {
        handler (period) {
          if (period && period.id) {
            this.loadStats()
          }
        },
        deep: true,
      },
    },
    created () {
      this.loadStats()
    },
    methods: {
      setStatsValues (incomes, expenses, difference) {
        this.stats = getStats(
          key => this.$t(key),
          incomes,
          expenses,
          difference,
        )
      },
      loadStats () {
        this.isStatsLoading = true
        this.$store.dispatch('dashboard/getStats', this.selectedPeriod.id)
          .then(({ data }) => {
            const { incomesSum, expensesSum, difference } = data
            this.setStatsValues(incomesSum, expensesSum, difference)
          })
          .finally(() => {
            this.isStatsLoading = false
          })
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          stats: {
            income: {
              title: 'Receitas',
              actionText: 'Soma das receitas no período.',
            },
            expense: {
              title: 'Despesas',
              actionText: 'Soma das despesas no período.',
            },
            difference: {
              title: 'Diferença',
              actionText: 'Receitas menos despesas.',
            },
          },
        },
        'en-US': {
          stats: {
            income: {
              title: 'Incomes',
              actionText: 'Sum of incomes for the period.',
            },
            expense: {
              title: 'Expenses',
              actionText: 'Sum of expenses in the period.',
            },
            difference: {
              title: 'Difference',
              actionText: 'Income minus expenses.',
            },
          },
        },
      },
    },
  }
</script>
